
# Check if the programm is started with powershell
use_powershell <- FALSE

if (length(commandArgs(trailingOnly = TRUE)) > 0) {
  # Get the command-line arguments
  
  # bei dem Aufruf mit PowerShell wird TRUE übergeben
  use_powershell <<- commandArgs(trailingOnly = TRUE)
  
  # Process the command-line arguments
  #for (arg in args) {
  # print(arg)}
  cat("\n")
  cat("####\n")
  cat("command-line arguments provided.: ")
  print(use_powershell)
  cat("####\n")
  cat("\n")
} else {
  cat("\n")
  cat("####\n")
  cat("No command-line arguments provided.\n") 
  cat("-> You are using an incomplete powershell command or R-Studio.\n")
  cat("####\n")
  cat("\n")
  # the powershell command must be handed over in the following form :  Rscript your_script.R arg1 arg2 arg3
}

#create global variable for the readline-command
choice <- T

function_create_validfrom <- function(combinedDataFrame){
  #nrow(cleaned_df)
  # Format für validfrom
  # 2023-10-23 08:02
  
  #erhöht den Tag immer um 1, damit das Skript ab dem nächsten Tag startet.
  date  <- paste(year(Sys.time()),,,sep="-")
  zyear <- year(Sys.time())
  zmonth <- month(Sys.time())
  zday <- day(Sys.time())+1
  list_for_hour <- c()
  
  for (i in 0:23){
    if(i<10){
      list_for_hour <- c(list_for_hour,paste0(zyear,"-",zmonth,"-",zday," ","0",i,":00"))
    } else{
      list_for_hour <- c(list_for_hour,paste0(zyear,"-",zmonth,"-",zday," ",i,":00"))
      }
  }
  print(list_for_hour)
  
  # es werden 300-500 Mails in einer Stunde versendet.
  # bei 24h werden somit zwischen 7200 und 12000 Mails versendet.
  # bei 100.000 werten und 7200 Mails muss ich also über 14 Tage gehen.
  
    # Erstelle einen leeren Vektor für die Datumswerte
  date_values <- c()
  
  # Schleife von 0 bis 23 Stunden
  for (i in 0:23) {
    # Erhöhe das Datum um eine Stunde
    current_date <- start_date + hours(i)
    
    # Füge das Datum zum Vektor hinzu
    date_values <- c(date_values, current_date)
    
    # Wenn die Stunde 23 ist, erhöhe den Tag um eins und setze die Stunde auf 0
    if (i == 23) {
      start_date <- start_date + days(1)  # Erhöhe den Tag um eins
      start_date <- start_date - hours(23) # Setze die Stunde auf 0
    }
  }
  
  
  anzahl_zeilen <- nrow(cleaned_df)
  
  # Schleife über die Anzahl der Zeilen
  for (i in 1:anzahl_zeilen) {
    # Schreibe den aktuellen Wert in die Spalte 'column_name'
    cleaned_df$validfrom[i] <- date
    
    # Aktualisiere den Wert nach jeweils 300 Zyklen
    if (i %% 300 == 0) {
      date <- wert + 1
    }
  }
  
  
  
  combined_token_with_download
}


#first: define all functions:
function_read_prompt <- function(){
   
  if(use_powershell){
    # Read input from file or standard input
    input <- file("stdin")
    
    # Print prompt and read user input
    cat("PS::EINGABE:")
    choice <<- scan(input, what = "character", n = 1)
    
    # Close input connection
    close(input)
  }
  else{
  
  #this command did not work properly using Powershell. 
  #so it is important to change the readline path depending on the environment
  # <<- so it is possible to change the global variable
  choice <<- readline(prompt = "rl::EINGABE:")
  
  }
}


function_start <- function(){

  # User interaction to choose a function
  cat("\n")
  cat("Die erforderlichen Vorarbeiten wurden erledigt: welche nachfolgenden Schritte sollen unternommen werden?\n")
  cat("\n")
  cat("Bitte wähle einen Pfad aus:\n")
  cat("----------------------------\n")
  cat("1 = Tokenaufbereiter alle TN:\n")
  cat("    wird verwendet, wenn alle registrierten Personen zu einer Umfrage eingeladen werden sollen.\n")
  cat("-------------------------------------------------------------------------------------------------------------------\n")
  cat("2 = Tokenaufbereiter Newsletter:\n")
  cat("    wird zum Newsletterversand verwendet.\n")
  cat("    Es werden bereits alle Personen entfernt, die keinen Newsletter mehr erhalten wollen.\n")
  cat("    Die Liste für die Abmeldung vom Newsletter wird von Mareike gewartet.\n")
  cat("    Die Datei: P://IMEBI//DigiHero_Teilnehmerdaten//Newsletter_Abmeldung.xlsx wird automatisch eingelesen.\n")
  cat("-------------------------------------------------------------------------------------------------------------------\n")
  cat("3 = Tokenaufbereiter MIT HHID als firstname:\n")
  cat("    wird verwendet, wenn TN angeschrieben werden, bei denen in der Mail eine Haushalts-ID angegeben wird.\n")
  cat("    Tokenliste + zugehörige Haushalts-ID erhält man von den wissenschaftlichen Mitarbeiter*innen.\n")
  cat("-------------------------------------------------------------------------------------------------------------------\n")
  cat("4 = Tokenaufbereiter OHNE HHID:\n")
  cat("    wird verwendet, wenn TN angeschrieben werden, bei denen in der Mail keine Haushalts-ID angegeben wird.\n")
  cat("    Tokenliste OHNE Haushald-ID erhält man von den wissenschaftlichen Mitarbeiter*innen\n")
  cat("-------------------------------------------------------------------------------------------------------------------\n")
  cat("9 = mir ist ein Fehler passiert. Es wird nichts gespeichert!\n")
  
  function_read_prompt()
  
  if (!choice %in% c("1","2","3","4","9")){
    cat("\n")
    cat("\n")
    cat("##################\n")
    cat("Ungültige Auswahl! Bitte verwende: 1, 2, 3, 4 oder 9. Danke.\n")
    cat("##################\n")
    cat("\n")
    cat("\n")
    function_start()
  }
  else{
    # Convert user input to integer
    choice <- as.integer(choice)
    if (choice == 1) {
      function_Tokenaufbereiter_alle_TN()
    } else if (choice == 2) {
      function_Tokenaufbereiter_Newsletter()
    } else if (choice == 3) {
      function_Tokenaufbereiter_MIT_HHID_als_firstname()
    } else if (choice == 4) {
      function_Tokenaufbereiter_OHNE_HHID()
    } else {
      function_exit()  
    }
    
  }
}

function_Tokenaufbereiter_alle_TN <- function() {
  cat("\n")
  cat("Tokenaufbereiter alle TN\n")
  cat("------------------------\n")
  cat("Es sind keine weiteren Schritte notwendig!\n")
  cat("\n")
  
  combined_token_with_download <- cleaned_df
  
  # zeilennummer erzeugen
  combined_token_with_download <- combined_token_with_download %>% mutate(id = row_number())
  
  #relocate
  combined_token_with_download <- combined_token_with_download |> relocate(token, .after = emailstatus)
  combined_token_with_download <- combined_token_with_download |> relocate(id, .before = firstname)
  
  #save the file
  #setwd("H:/01_Limesurvey_TokenVergleich")
  write.csv(combined_token_with_download,paste0("./Umfrageteilnehmertabelle_",format(Sys.Date(), "%Y_%m_%d"),"_alle_TN.csv"), row.names = F)
  
  
  function_end()
  
}

function_Tokenaufbereiter_Newsletter <- function() {
  cat("\n")
  cat("Tokenaufbereiter Newsletter\n")
  cat("---------------------------\n")
  cat("Die Liste für die Abmeldung vom Newsletter wird von Mareike gewartet.\n")
  cat("Die Datei: P://IMEBI//DigiHero_Teilnehmerdaten//Newsletter_Abmeldung.xlsx wird automatisch eingelesen.\n")
  #cat("In der Regel findet sich die Datei in:\n")
  #cat("P:\\IMEBI\\DigiHero\\10_Auswertung\\Datenablage für MK und YF\\Newsletter_ohne_TH.xlsx \n")
  if(use_powershell){
    cat("Fortfarhren? Press [y + ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")  
  }else{ 
    cat("Fortfarhren? Press [ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")
  }
  function_read_prompt()
  
    if (choice == "y" || choice == ""){
      #Eingabe: [ENTER] -> weiter gehts
      
      #laden und joinen
      #token_list <- read_xlsx(file.choose())
      #combined_token_with_download <- inner_join(token_list,cleaned_df, by="token")
      combined_token_with_download <- cleaned_df
      
      # zeilennummer erzeugen
      combined_token_with_download <- combined_token_with_download %>% mutate(id = row_number())
      
      #relocate
      combined_token_with_download <- combined_token_with_download |> relocate(token, .after = emailstatus)
      combined_token_with_download <- combined_token_with_download |> relocate(id, .before = firstname)
     
      #specific deletion
      token_for_newsletter_to_remove <- read_xlsx("P:/IMEBI/DigiHero_Teilnehmerdaten/Newsletter_Abmeldung.xlsx", sheet="combined")
      
      #tokens_to_remove <- c("fcNJSEZXp6aja09", "i2UWfmddV8IDv52", "7jBwCVzYVy1BHKz", "9WRI8lvhqufm9zE",
      #                      "uVfhUNYG8UePYfy", "il1xCGz2nB30Cvg", "2t06iU8tbN6Gsdb", "iydZWTsI3f4dC2z")
      
      #filter alle gegebenen token aus der der Newsletter_Abmeldung heraus
      combined_token_with_download <- combined_token_with_download %>% 
        filter(!token %in% token_for_newsletter_to_remove$token)
      
      #save the file
      #setwd("H:/01_Limesurvey_TokenVergleich")
      write.csv(combined_token_with_download,paste0("./Umfrageteilnehmertabelle_",format(Sys.Date(), "%Y_%m_%d"),"_Newsletter.csv"), row.names = F)
      
      function_end()
    
  } else{
    #Eingabe: irgendwas ausser [ENTER] -> Abbruch
    function_exit()
  }
}


function_Tokenaufbereiter_MIT_HHID_als_firstname <- function() {
  cat("\n")
  cat("Tokenaufbereiter MIT HHID als firstname\n")
  cat("---------------------------------------\n")
  cat("Die Tokenlisten werden von den wissenschaftlichen Mitarbeiter*innen erstellt.\n")
  cat("In der Regel findet sich die Datei in:\n")
  cat("P:\\IMEBI\\DigiHero\\10_Auswertung\\Datenablage für MK und YF\\LC_Token_Baseline_KurzeBefragung_2023-01-17.xlsx \n")
  
  if(use_powershell){
    cat("Hast du die Datei? Press [y + ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")  
  }else{ 
    cat("Hast du die Datei? Press [ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")
  }
  function_read_prompt()
  
  if (choice == "y" || choice == ""){
    #Eingabe: [ENTER] -> weiter gehts
    
    #laden und joinen
    token_list <- tryCatch({
      read_xlsx(file.choose())
      }, error = function(e) {
        message("Failure: ",conditionMessage(e))
        NULL
        function_exit()
      })

    combined_token_with_download <- inner_join(token_list,cleaned_df, by="token")
    
    #rename
    combined_token_with_download <- combined_token_with_download %>%
      rename(first = firstname)
    combined_token_with_download <- combined_token_with_download %>%
      rename(last = lastname)
    combined_token_with_download$lastname <- paste(combined_token_with_download$first,
                                                   combined_token_with_download$last, sep = " ")
    combined_token_with_download <- combined_token_with_download %>%
      rename(firstname = hhid)
    combined_token_with_download$first <- NULL
    combined_token_with_download$last <- NULL
    
    # zeilennummer erzeugen
    combined_token_with_download <- combined_token_with_download %>% mutate(id = row_number())
    
    #relocate
    combined_token_with_download <- combined_token_with_download |> relocate(id, .before = firstname)
    combined_token_with_download <- combined_token_with_download |> relocate(lastname, .after = firstname)
    combined_token_with_download <- combined_token_with_download |> relocate(token, .after = emailstatus)
    
    #save the file
    #setwd("H:/01_Limesurvey_TokenVergleich")
    write.csv(combined_token_with_download,paste0("./Umfrageteilnehmertabelle_",format(Sys.Date(), "%Y_%m_%d"),"_mit_HHID_as_firstname.csv"), row.names = F)
    
    function_end()
    
  } else{
    #Eingebe: irgenwas auser [ENTER] -> Abbruch
    function_exit()
  }
}

function_Tokenaufbereiter_OHNE_HHID <- function() {
  cat("\n")
  cat("Tokenaufbereiter OHNE HHID\n")
  cat("--------------------------\n")
  cat("Die Tokenlisten werden von den wissenschaftlichen Mitarbeiter*innen erstellt.\n")
  cat("In der Regel findet sich die Datei in:\n")
  cat("P:\\IMEBI\\DigiHero\\10_Auswertung\\Dunkelziffer_Immunstatus\\Token_Auswahl_DBS\\Token_DigiHero_Immunstatus_DBS_1500.xlsx \n")
  if(use_powershell){
    cat("Hast du die Datei? Press [y + ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")  
  }else{ 
    cat("Hast du die Datei? Press [ENTER]. Ansonsten kann das Script mit Eingabe von [e + ENTER] beendet werden\n")
  }
  
  function_read_prompt()
  
  if (choice == "y" || choice == ""){
    #Eingabe: [ENTER] -> weiter gehts
    
    #laden und joinen
    token_list <- tryCatch({
      read_xlsx(file.choose())
      }, error = function(e) {
        message("Failure: ",conditionMessage(e))
        NULL
        function_exit()
      })
    combined_token_with_download <- inner_join(token_list,cleaned_df, by="token")
    
    # zeilennummer erzeugen
    combined_token_with_download <- combined_token_with_download %>% mutate(id = row_number())
    
    #relocate
    combined_token_with_download <- combined_token_with_download |> relocate(token, .after = emailstatus)
    combined_token_with_download <- combined_token_with_download |> relocate(id, .before = firstname)
    
    
    #save the file
    setwd("H:/01_Limesurvey_TokenVergleich")
    write.csv(combined_token_with_download,paste0("./Umfrageteilnehmertabelle_",format(Sys.Date(), "%Y_%m_%d"),"_ohne_HHID.csv"), row.names = F)
    
    function_end()
    
  } else{
    #Eingabe: irgenwas auser [ENTER] -> Abbruch
    function_exit()
  }
  
  
}


function_exit <- function() {
  cat("\n")
  cat("Script wird beendet. Es erfolgt keine Speicherung irgendwelcher Dateien.\n")
  if(use_powershell){
    cat("Press [y + ENTER] to quit the Script without saving informations.\n")
    cat("I wish you a wonderfull day!: ")
    function_read_prompt()
    quit()
  } else{
    cat("Press [ENTER] to quit the Script without saving informations.\n")
    cat("I wish you a wonderfull day!: ")
    function_read_prompt()
    #dont use quit() -> it restarts your R-Studio
  }
  
  
  
}

function_end <- function(){
  cat("\n")
  cat("Es wurde alle notwendigen Schritte zur Bearbeitung und Speicherung unternommen.\n")
  if(use_powershell){
    cat("Press [y + ENTER] to quit the Script.\n")
    cat("I wish you a wonderfull day!: ")
    function_read_prompt()
    quit()
  } else{
    cat("Press [ENTER] to quit the Script.\n")
    cat("I wish you a wonderfull day!: ")
    function_read_prompt()
    #dont use quit() -> it restarts your R-Studio
  }
}
